function [residual, g1, g2] = ABK_static(y, x, params)
%
% Status : Computes static model for Dynare
%
% Inputs : 
%   y         [M_.endo_nbr by 1] double    vector of endogenous variables in declaration order
%   x         [M_.exo_nbr by 1] double     vector of exogenous variables in declaration order
%   params    [M_.param_nbr by 1] double   vector of parameter values in declaration order
%
% Outputs:
%   residual  [M_.endo_nbr by 1] double    vector of residuals of the static model equations 
%                                          in order of declaration of the equations
%   g1        [M_.endo_nbr by M_.endo_nbr] double    Jacobian matrix of the static model equations;
%                                                     columns: variables in declaration order
%                                                     rows: equations in order of declaration
%   g2        [M_.endo_nbr by (M_.endo_nbr)^2] double   Hessian matrix of the static model equations;
%                                                       columns: variables in declaration order
%                                                       rows: equations in order of declaration
%
%
% Warning : this file is generated automatically by Dynare
%           from model file (.mod)

residual = zeros( 36, 1);

%
% Model equations
%

I_ss__ = (y(7));
Rstar_ss__ = (y(35));
ystar_ss__ = (y(36));
T18 = 1/y(34);
T22 = T18*y(19)^params(5);
T29 = y(18)^params(7);
T51 = y(6)-params(16)*y(3)^(1+params(15))/(1+params(15));
T53 = params(14)*T51/T51;
T63 = (y(2)/params(5))^params(5);
T64 = y(34)*T63;
T67 = (y(4)/params(6))^params(6);
T68 = T64*T67;
T70 = (y(3)/params(7))^params(7);
T115 = y(7)/I_ss__-1;
T116 = T115^2;
T171 = params(1)*(1+params(2)*y(23)^2/2);
T184 = 1+2/params(2)*(y(28)/y(27))^2;
T187 = (-1)+T184^0.5;
T198 = params(13)/2*(y(16)-1)^2;
T308 = (-(params(16)*getPowerDeriv(y(3),1+params(15),1)/(1+params(15))));
T314 = (T51*params(14)*T308-params(14)*T51*T308)/(T51*T51);
T351 = (I_ss__-y(7))/(I_ss__*I_ss__)*2*T115;
T384 = 1/y(12)-1/(y(12));
T563 = (Rstar_ss__-y(35))/(Rstar_ss__*Rstar_ss__)/(y(35)/Rstar_ss__);
T570 = (ystar_ss__-y(36))/(ystar_ss__*ystar_ss__)/(y(36)/ystar_ss__);
lhs =y(15);
rhs =T22*y(17)^params(6)*T29;
residual(1)= lhs-rhs;
lhs =y(16)*(y(16)-1);
rhs =1/params(13)*(1+y(15)*params(9)-params(9))+(y(16)-1)*y(16)*T53*y(1)/y(1);
residual(2)= lhs-rhs;
lhs =y(1);
rhs =T68*T70;
residual(3)= lhs-rhs;
lhs =params(5)*y(17)*y(4);
rhs =y(2)*y(19)*params(6);
residual(4)= lhs-rhs;
lhs =params(5)*y(18)*y(3);
rhs =y(2)*y(19)*params(7);
residual(5)= lhs-rhs;
lhs =y(2);
rhs =y(7)+y(2)*(1-params(8));
residual(6)= lhs-rhs;
lhs =y(5);
rhs =y(36)*y(17)^params(12);
residual(7)= lhs-rhs;
lhs =y(18);
rhs =params(16)*y(3)^params(15);
residual(8)= lhs-rhs;
lhs =y(22);
rhs =(1+y(21))/y(16);
residual(9)= lhs-rhs;
lhs =T53*(y(19)+(1-params(8))*y(20))/(y(20)+params(17)*y(13));
rhs =1;
residual(10)= lhs-rhs;
lhs =T53*y(22);
rhs =1;
residual(11)= lhs-rhs;
lhs =y(20);
rhs =1+params(11)*T116/2+T115*params(11)*y(7)/I_ss__;
residual(12)= lhs-rhs;
lhs =y(31)*y(8);
rhs =y(17)*y(30)*y(10)+y(20)*y(29)*y(12);
residual(13)= lhs-rhs;
lhs =y(14);
rhs =T53*(1-params(3)+params(3)*y(25));
residual(14)= lhs-rhs;
lhs =y(27);
rhs =y(14)*((y(19)+(1-params(8))*y(20))/y(20)-y(22)*(1+y(29)));
residual(15)= lhs-rhs;
lhs =y(28);
rhs =y(14)*(y(22)*(1-y(30))-y(35));
residual(16)= lhs-rhs;
lhs =y(26);
rhs =y(22)*y(14)*(1+y(31));
residual(17)= lhs-rhs;
lhs =y(24);
rhs =y(26)/(T171-(y(27)+y(28)*y(23)));
residual(18)= lhs-rhs;
lhs =y(25);
rhs =y(24)*T171;
residual(19)= lhs-rhs;
lhs =y(23);
rhs =y(27)/y(28)*T187;
residual(20)= lhs-rhs;
lhs =y(1);
rhs =y(5)+y(6)+y(7)*(1+T116*params(11)/2)+y(1)*T198+params(17)*y(13)^2/2;
residual(21)= lhs-rhs;
lhs =y(10);
rhs =y(4)+y(35)*y(10)-y(5)/y(17);
residual(22)= lhs-rhs;
lhs =y(8);
rhs =y(12)*(y(19)+(1-params(8))*y(20))*(params(3)+params(4))-y(22)*params(3)*y(9)-y(10)*y(17)*y(35)*params(3);
residual(23)= lhs-rhs;
lhs =y(20)*y(12);
rhs =y(8)*y(24);
residual(24)= lhs-rhs;
lhs =y(20)*y(12);
rhs =y(8)+y(9)+y(17)*y(10);
residual(25)= lhs-rhs;
lhs =y(23);
rhs =y(17)*y(10)/(y(20)*y(12));
residual(26)= lhs-rhs;
lhs =y(2);
rhs =y(13)+y(12);
residual(27)= lhs-rhs;
lhs =y(21)-(y(21));
rhs =(y(16)-1)*(1-params(25))*params(26)+(y(21)-(y(21)))*params(25)+x(3);
residual(28)= lhs-rhs;
lhs =y(11);
rhs =y(5)+y(6)+y(7)*(1+T116/2)-y(17)*y(4);
residual(29)= lhs-rhs;
lhs =y(32);
rhs =log(T51);
residual(30)= lhs-rhs;
lhs =y(33);
rhs =y(32)+params(14)*y(33);
residual(31)= lhs-rhs;
lhs =y(29);
rhs =params(27)*(log(y(12))-log((y(12))));
residual(32)= lhs-rhs;
lhs =y(30);
rhs =(log(y(12))-log((y(12))))*params(28);
residual(33)= lhs-rhs;
lhs =log(y(34));
rhs =log(y(34))*params(19)+x(1);
residual(34)= lhs-rhs;
lhs =log(y(35)/Rstar_ss__);
rhs =log(y(35)/Rstar_ss__)*params(18)+x(2);
residual(35)= lhs-rhs;
lhs =log(y(36)/ystar_ss__);
rhs =log(y(36)/ystar_ss__)*params(20)+x(4);
residual(36)= lhs-rhs;
if ~isreal(residual)
  residual = real(residual)+imag(residual).^2;
end
if nargout >= 2,
  g1 = zeros(36, 36);

  %
  % Jacobian matrix
  %

  g1(1,15)=1;
  g1(1,17)=(-(T29*T22*getPowerDeriv(y(17),params(6),1)));
  g1(1,18)=(-(T22*y(17)^params(6)*getPowerDeriv(y(18),params(7),1)));
  g1(1,19)=(-(T29*y(17)^params(6)*T18*getPowerDeriv(y(19),params(5),1)));
  g1(1,34)=(-(T29*y(17)^params(6)*y(19)^params(5)*(-1)/(y(34)*y(34))));
  g1(2,3)=(-((y(16)-1)*y(16)*y(1)*T314/y(1)));
  g1(2,15)=(-(1/params(13)*params(9)));
  g1(2,16)=y(16)+y(16)-1-(y(16)*T53*y(1)/y(1)+(y(16)-1)*T53*y(1)/y(1));
  g1(3,1)=1;
  g1(3,2)=(-(T70*T67*y(34)*1/params(5)*getPowerDeriv(y(2)/params(5),params(5),1)));
  g1(3,3)=(-(T68*1/params(7)*getPowerDeriv(y(3)/params(7),params(7),1)));
  g1(3,4)=(-(T70*T64*1/params(6)*getPowerDeriv(y(4)/params(6),params(6),1)));
  g1(3,34)=(-(T70*T63*T67));
  g1(4,2)=(-(y(19)*params(6)));
  g1(4,4)=params(5)*y(17);
  g1(4,17)=params(5)*y(4);
  g1(4,19)=(-(params(6)*y(2)));
  g1(5,2)=(-(y(19)*params(7)));
  g1(5,3)=params(5)*y(18);
  g1(5,18)=params(5)*y(3);
  g1(5,19)=(-(params(7)*y(2)));
  g1(6,2)=1-(1-params(8));
  g1(6,7)=(-1);
  g1(7,5)=1;
  g1(7,17)=(-(y(36)*getPowerDeriv(y(17),params(12),1)));
  g1(7,36)=(-(y(17)^params(12)));
  g1(8,3)=(-(params(16)*getPowerDeriv(y(3),params(15),1)));
  g1(8,18)=1;
  g1(9,16)=(-((-(1+y(21)))/(y(16)*y(16))));
  g1(9,21)=(-(1/y(16)));
  g1(9,22)=1;
  g1(10,3)=(y(19)+(1-params(8))*y(20))/(y(20)+params(17)*y(13))*T314;
  g1(10,13)=T53*(-((y(19)+(1-params(8))*y(20))*params(17)))/((y(20)+params(17)*y(13))*(y(20)+params(17)*y(13)));
  g1(10,19)=T53*1/(y(20)+params(17)*y(13));
  g1(10,20)=T53*((1-params(8))*(y(20)+params(17)*y(13))-(y(19)+(1-params(8))*y(20)))/((y(20)+params(17)*y(13))*(y(20)+params(17)*y(13)));
  g1(11,3)=y(22)*T314;
  g1(11,22)=T53;
  g1(12,7)=(-(params(11)*T351/2+params(11)*y(7)/I_ss__*(I_ss__-y(7))/(I_ss__*I_ss__)+T115*params(11)*(I_ss__-y(7))/(I_ss__*I_ss__)));
  g1(12,20)=1;
  g1(13,8)=y(31);
  g1(13,10)=(-(y(17)*y(30)));
  g1(13,12)=(-(y(20)*y(29)));
  g1(13,17)=(-(y(30)*y(10)));
  g1(13,20)=(-(y(29)*y(12)));
  g1(13,29)=(-(y(20)*y(12)));
  g1(13,30)=(-(y(17)*y(10)));
  g1(13,31)=y(8);
  g1(14,3)=(-((1-params(3)+params(3)*y(25))*T314));
  g1(14,14)=1;
  g1(14,25)=(-(T53*params(3)));
  g1(15,14)=(-((y(19)+(1-params(8))*y(20))/y(20)-y(22)*(1+y(29))));
  g1(15,19)=(-(y(14)*1/y(20)));
  g1(15,20)=(-(y(14)*((1-params(8))*y(20)-(y(19)+(1-params(8))*y(20)))/(y(20)*y(20))));
  g1(15,22)=(-(y(14)*(-(1+y(29)))));
  g1(15,27)=1;
  g1(15,29)=(-(y(14)*(-y(22))));
  g1(16,14)=(-(y(22)*(1-y(30))-y(35)));
  g1(16,22)=(-(y(14)*(1-y(30))));
  g1(16,28)=1;
  g1(16,30)=(-(y(14)*(-y(22))));
  g1(16,35)=y(14);
  g1(17,14)=(-(y(22)*(1+y(31))));
  g1(17,22)=(-(y(14)*(1+y(31))));
  g1(17,26)=1;
  g1(17,31)=(-(y(22)*y(14)));
  g1(18,23)=(-((-(y(26)*(params(1)*params(2)*2*y(23)/2-y(28))))/((T171-(y(27)+y(28)*y(23)))*(T171-(y(27)+y(28)*y(23))))));
  g1(18,24)=1;
  g1(18,26)=(-(1/(T171-(y(27)+y(28)*y(23)))));
  g1(18,27)=(-(y(26)/((T171-(y(27)+y(28)*y(23)))*(T171-(y(27)+y(28)*y(23))))));
  g1(18,28)=(-((-(y(26)*(-y(23))))/((T171-(y(27)+y(28)*y(23)))*(T171-(y(27)+y(28)*y(23))))));
  g1(19,23)=(-(y(24)*params(1)*params(2)*2*y(23)/2));
  g1(19,24)=(-T171);
  g1(19,25)=1;
  g1(20,23)=1;
  g1(20,27)=(-(T187*1/y(28)+y(27)/y(28)*2/params(2)*(-y(28))/(y(27)*y(27))*2*y(28)/y(27)*0.5*T184^(-0.5)));
  g1(20,28)=(-(T187*(-y(27))/(y(28)*y(28))+y(27)/y(28)*0.5*T184^(-0.5)*2/params(2)*2*y(28)/y(27)*1/y(27)));
  g1(21,1)=1-T198;
  g1(21,5)=(-1);
  g1(21,6)=(-1);
  g1(21,7)=(-(1+T116*params(11)/2+y(7)*params(11)/2*T351));
  g1(21,13)=(-(params(17)*2*y(13)/2));
  g1(21,16)=(-(y(1)*params(13)/2*2*(y(16)-1)));
  g1(22,4)=(-1);
  g1(22,5)=1/y(17);
  g1(22,10)=1-y(35);
  g1(22,17)=(-y(5))/(y(17)*y(17));
  g1(22,35)=(-y(10));
  g1(23,8)=1;
  g1(23,9)=y(22)*params(3);
  g1(23,10)=y(17)*y(35)*params(3);
  g1(23,12)=(-((y(19)+(1-params(8))*y(20))*(params(3)+params(4))));
  g1(23,17)=y(10)*y(35)*params(3);
  g1(23,19)=(-(y(12)*(params(3)+params(4))));
  g1(23,20)=(-(y(12)*(1-params(8))*(params(3)+params(4))));
  g1(23,22)=params(3)*y(9);
  g1(23,35)=y(10)*y(17)*params(3);
  g1(24,8)=(-y(24));
  g1(24,12)=y(20);
  g1(24,20)=y(12);
  g1(24,24)=(-y(8));
  g1(25,8)=(-1);
  g1(25,9)=(-1);
  g1(25,10)=(-y(17));
  g1(25,12)=y(20);
  g1(25,17)=(-y(10));
  g1(25,20)=y(12);
  g1(26,10)=(-(y(17)/(y(20)*y(12))));
  g1(26,12)=(-((-(y(20)*y(17)*y(10)))/(y(20)*y(12)*y(20)*y(12))));
  g1(26,17)=(-(y(10)/(y(20)*y(12))));
  g1(26,20)=(-((-(y(12)*y(17)*y(10)))/(y(20)*y(12)*y(20)*y(12))));
  g1(26,23)=1;
  g1(27,2)=1;
  g1(27,12)=(-1);
  g1(27,13)=(-1);
  g1(28,16)=(-((1-params(25))*params(26)));
  g1(29,4)=y(17);
  g1(29,5)=(-1);
  g1(29,6)=(-1);
  g1(29,7)=(-(1+T116/2+y(7)*T351/2));
  g1(29,11)=1;
  g1(29,17)=y(4);
  g1(30,3)=(-(T308/T51));
  g1(30,6)=(-(1/T51));
  g1(30,32)=1;
  g1(31,32)=(-1);
  g1(31,33)=1-params(14);
  g1(32,12)=(-(params(27)*T384));
  g1(32,29)=1;
  g1(33,12)=(-(params(28)*T384));
  g1(33,30)=1;
  g1(34,34)=T18-T18*params(19);
  g1(35,35)=T563-params(18)*T563;
  g1(36,36)=T570-params(20)*T570;
  if ~isreal(g1)
    g1 = real(g1)+2*imag(g1);
  end
end
if nargout >= 3,
  %
  % Hessian matrix
  %

  g2 = sparse([],[],[],36,1296);
end
end
